//---------------------------------------------------------------------------
#include <vcl.h>
#include <ddraw.h>
#pragma hdrstop
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be perfomring new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------
USERES("GUI.res");
USEFORM("UfrmJoypad.cpp", frmJoypad);
USEFORM("UfrmDirectX.cpp", frmDirectX);
USEFORM("UfrmTestDisplayMode.cpp", frmTestDisplayMode);
USEFORM("UfrmOpenROM.cpp", frmOpenRom);
//---------------------------------------------------------------------------
extern "C" void __export __cdecl InitDLL( HANDLE hWnd)
{
    Application->Handle = hWnd;
}
#include "UfrmOpenROM.h"
#include "..\\snes9x\\snes9x.h"
extern "C" bool __export __cdecl OpenROM( char *FileName, struct SSettings *Settings)
{
bool Result = false;
    frmOpenROM = new TfrmOpenROM( Application);

    frmOpenROM -> cbx_MemMap -> ItemIndex = !Settings -> ForceLoROM && !Settings -> ForceHiROM ? 0 : Settings -> ForceLoROM ? 1 : 2;
    frmOpenROM -> cbx_Interleave -> ItemIndex = !Settings -> ForceNotInterleaved && !Settings -> ForceInterleaved && !Settings -> ForceInterleaved2 ? 0 : Settings -> ForceNotInterleaved ? 1 : Settings -> ForceInterleaved ? 2 : 3;
    frmOpenROM -> cbx_System -> ItemIndex = !Settings -> ForcePAL && !Settings -> ForceNTSC ? 0 : Settings -> ForcePAL ? 1 : 2;
    frmOpenROM -> cbx_Header -> ItemIndex = !Settings -> ForceHeader && !Settings -> ForceNoHeader ? 0 : Settings -> ForceNoHeader ? 1 : 2;

    if( frmOpenROM -> ShowModal() == 1)
    {
    System::String FN;
        Settings -> ForceLoROM = false;
        Settings -> ForceHiROM = false;
        switch( frmOpenROM -> cbx_MemMap -> ItemIndex)
        {
            case 1: Settings -> ForceLoROM = true; break;
            case 2: Settings -> ForceHiROM = true; break;
        }

        Settings -> ForceNotInterleaved = false;
        Settings -> ForceInterleaved = false;
        Settings -> ForceInterleaved2 = false;
        switch( frmOpenROM -> cbx_Interleave -> ItemIndex)
        {
            case 1: Settings -> ForceNotInterleaved = true; break;
            case 2: Settings -> ForceInterleaved = true; break;
            case 3: Settings -> ForceInterleaved2 = true; break;
        }

        Settings -> ForcePAL = false;
        Settings -> ForceNTSC = false;
        switch( frmOpenROM -> cbx_System -> ItemIndex)
        {
            case 1: Settings -> ForcePAL = true; break;
            case 2: Settings -> ForceNTSC = true; break;
        }

        Settings -> ForceHeader = false;
        Settings -> ForceNoHeader = false;
        switch( frmOpenROM -> cbx_System -> ItemIndex)
        {
            case 1: Settings -> ForceNoHeader = true; break;
            case 2: Settings -> ForceHeader = true; break;
        }

        FN = frmOpenROM -> DirectoryTreeView -> Directory;
        FN += frmOpenROM -> ListView -> Selected -> Caption;

        StrPCopy( FileName, FN);
        Result = true;
    }
    delete frmOpenROM;
    return Result;
}
//---------------------------------------------------------------------------
#include "UfrmJoypad.h"
extern struct SJoypad Joypad[4];
extern "C" void __export __cdecl JoypadConfig( struct SJoypad *J)
{
    frmJoypad = new TfrmJoypad( Application);
    Joypad[0] = J[0];
    Joypad[1] = J[1];
    Joypad[2] = J[2];
    Joypad[3] = J[3];
    if( frmJoypad -> ShowModal() == 1)
    {
        J[0] = Joypad[0];
        J[1] = Joypad[1];
        J[2] = Joypad[2];
        J[3] = Joypad[3];
    }
    delete frmOpenROM;
    return;
}
//---------------------------------------------------------------------------
#include "UfrmDirectX.h"
extern LPDIRECTDRAW lpDD;

struct sGUI {
	HWND hWnd;
	HMENU hMenu;
	HINSTANCE hInstance;

	DWORD hFrameTimer;
	HANDLE hDrawFrame;
	DWORD FrameTimerStart;

	BYTE Language;

	char SoundMode;
	bool Stereo;

	bool PauseEmulation;
	bool StopEmulation;

	int Width;
	int Height;
	int Depth;
	int Scale;
	bool DoubleBuffered;
    bool TVMode;
};

extern "C" void __export __cdecl DirectXConfig( LPDIRECTDRAW plpDD, struct SSettings *Settings, struct sGUI *GUI, bool *showFPS)
{
    frmDirectX = new TfrmDirectX( Application);
    lpDD = plpDD;
    frmDirectX -> cbx_Sixteenbit -> Checked = Settings -> SixteenBit;
    frmDirectX -> cbx_Transparency -> Checked = Settings -> Transparency;
    frmDirectX -> cbx_HiRES -> Checked = Settings -> SupportHiRes;
    frmDirectX -> cbx_AutoFramerate -> Checked = Settings -> SkipFrames == 200;
    frmDirectX -> tb_SkipFrames -> Position = Settings -> SkipFrames < 200 ? Settings -> SkipFrames : 0;
    frmDirectX -> dWidth = GUI -> Width;
    frmDirectX -> dHeight = GUI -> Height;
    frmDirectX -> dDepth = GUI -> Depth;
    frmDirectX -> cbx_Stretch -> Checked = GUI -> Scale == 2;
    frmDirectX -> cbx_TVMode -> Checked = GUI -> TVMode;
    frmDirectX -> cbx_ShowFPS -> Checked = *showFPS;
    if( frmDirectX -> ShowModal() == 1)
    {
        Settings -> SixteenBit = frmDirectX -> cbx_Sixteenbit -> Checked;
        Settings -> Transparency = frmDirectX -> cbx_Transparency -> Checked;
        Settings -> SupportHiRes = frmDirectX -> cbx_HiRES -> Checked;
        Settings -> SkipFrames = frmDirectX -> cbx_AutoFramerate -> Checked ? 200 : frmDirectX -> tb_SkipFrames -> Position;

        GUI -> Width = frmDirectX -> dWidth;
        GUI -> Height = frmDirectX -> dHeight;
        GUI -> Depth = frmDirectX -> dDepth;
        GUI -> Scale = frmDirectX -> cbx_Stretch -> Checked ? 2 : 1;
        GUI -> TVMode = frmDirectX -> cbx_TVMode -> Checked;
        *showFPS = frmDirectX -> cbx_ShowFPS -> Checked;
    }
    delete frmDirectX;
    return;
}
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}
//---------------------------------------------------------------------------
